using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using RFramework;

namespace RFrameGenerate.Model
{
    public partial class T_BAS_MemberAccount : EntityBase<T_BAS_MemberAccount>, ICloneable
    {
        public Guid MemberAccountGuid{ get;set; }
        public Guid? MemberGuid{ get;set; }   
        public string TradingCode{ get;set; }
        public string TradingMain{ get;set; }
        public decimal? AvailableBalance{ get;set; }   
        public int? TradingType{ get;set; }   
        public Guid? FactorageSubjectGuid{ get;set; }   
        public decimal? TradingAmount{ get;set; }   
        public DateTime? TradingDate{ get;set; }   
        public string ReciprocalAccount{ get;set; }
        public string Remark{ get;set; }
        public Guid? MerchantGuid{ get;set; }   
        public Guid? SMerchantGuid{ get;set; }   
        
        public override string ToString()
        {
            StringBuilder sb = this.EntityToGetKeyValue();
            if (sb == null)
                return base.ToString();
            else
            {
                return sb.ToString();
            }
        }
        
        #region 创建副本
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public object Clone()
        {
            return this.MemberwiseClone();
        }
        /// <summary>
        /// 创建当前 System.Object 的深表副本
        /// </summary>
        /// <returns>返回当前实例的深表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_BAS_MemberAccount DeepClone()
        {
            using (System.IO.Stream objectStream = new System.IO.MemoryStream())
            {
                System.Runtime.Serialization.IFormatter formatter = new System.Runtime.Serialization.Formatters.Binary.BinaryFormatter();
                formatter.Serialize(objectStream, this);
                objectStream.Seek(0, System.IO.SeekOrigin.Begin);
                return formatter.Deserialize(objectStream) as T_BAS_MemberAccount;
            }
        }
        /// <summary>
        /// 创建当前 System.Object 的浅表副本
        /// </summary>
        /// <returns>返回当前实例的浅表副本,(如果当前实例中有引用对象,引用对象的地址还是指向原来的地址)</returns>
        public T_BAS_MemberAccount ShallowClone()
        {
            return Clone() as T_BAS_MemberAccount;
        }
        #endregion
        
        #region 实体相互转换
        protected override T_BAS_MemberAccount CurrentEntity()
        {
            return this;
        }
        #endregion
    }
}

